︠93ae871e-212c-45cd-9c79-dc56cd0366f7s︠
def exponent(p,power,E):
    #assumes p does not divide |E(F_p)|.
    Ep = E.reduction(p)
    exp = Ep.abelian_group().generator_orders()[0]
    return exp*p^(power-1) 
def is_Euler_elliptic_Carmichael_number(E,N):
    if gcd(E.discriminant(),N) > 1:
        return false
    factorization = list(factor(N))
    if len(factorization) <= 1: return false
    cond = E.conductor()
    aN = 1
    prime_coefficients = {}
    #compute ap, aN
    for prime, power in factorization:
        listy = [1, prime+1-E.Np(prime)]
        char = 1
        if mod(cond,prime) == 0:
            char = 0
        for j in range(2,power+1):
            listy.append(listy[1]*listy[j-1]-char*prime*listy[j-2])
        aN = aN*listy[-1]
        prime_coefficients[prime] = listy[1]
    if mod(N+1-aN,2) != 0:
        return false
    #check 2*(exponent of group E(Z/p^ord_p(N)Z) divides (N+1-an)/2.
    for prime, power in factorization:
        exp = exponent(prime,power,E)
        if mod(Integer(N+1-aN), 2*exp) != 0:
            return false
    return true

A,B = 0,80
E = EllipticCurve([A,B])
count = 1
N = 1
while true:
    if is_Euler_elliptic_Carmichael_number(E,N):
        print count, N
        count+=1
    N+=1
︡8f5e480c-bc19-4313-bdec-347a7bc0207c︡{"stdout":"1"}︡{"stdout":" 481\n2"}︡{"stdout":" 1679\n3 1763\n4"}︡{"stdout":" 3599\n5"}︡{"stdout":" 4991\n6"}︡{"stdout":" 5183\n7"}︡{"stdout":" 6119\n8"}︡{"stdout":" 7859\n9"}︡{"stdout":" 9271\n10"}︡{"stdout":" 9407\n11"}︡{"stdout":" 9599\n12"}︡︡{"stdout":" 18239\n13"}︡{"stdout":" 24119\n14"}︡{"stdout":" 24511\n15"}︡{"stdout":" 24803\n16"}︡{"stdout":" 31919\n17"}︡{"stdout":" 38111\n18"}︡{"stdout":" 38999\n19"}︡{"stdout":" 46079\n"}︡{"stderr":"Error in lines 33-37\n"}︡{"stderr":"Traceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1044, in execute\n    exec compile(block+'\\n', '', 'single', flags=compile_flags) in namespace, locals\n  File \"\", line 2, in <module>\n  File \"\", line 21, in is_Euler_elliptic_Carmichael_number\n  File \"\", line 3, in exponent\n  File \"sage/misc/cachefunc.pyx\", line 2016, in sage.misc.cachefunc.CachedMethodCaller.__call__ (build/cythonized/sage/misc/cachefunc.c:10855)\n    w = self._instance_call(*args, **kwds)\n  File \"sage/misc/cachefunc.pyx\", line 1892, in sage.misc.cachefunc.CachedMethodCaller._instance_call (build/cythonized/sage/misc/cachefunc.c:10306)\n    return self.f(self._instance, *args, **kwds)\n  File \"/ext/sage/sage-8.1/local/lib/python2.7/site-packages/sage/schemes/elliptic_curves/ell_finite_field.py\", line 1633, in abelian_group\n    return AdditiveAbelianGroupWrapper(self.point_homset(), gens, orders)\n  File \"/ext/sage/sage-8.1/local/lib/python2.7/site-packages/sage/groups/additive_abelian/additive_abelian_wrapper.py\", line 165, in __init__\n    addgp.AdditiveAbelianGroup_fixed_gens.__init__(self, cover, rels, cover.gens())\n  File \"/ext/sage/sage-8.1/local/lib/python2.7/site-packages/sage/groups/additive_abelian/additive_abelian_group.py\", line 416, in __init__\n    AdditiveAbelianGroup_class.__init__(self, cover, rels)\n  File \"/ext/sage/sage-8.1/local/lib/python2.7/site-packages/sage/groups/additive_abelian/additive_abelian_group.py\", line 227, in __init__\n    FGP_Module_class.__init__(self, cover, relations)\n  File \"/ext/sage/sage-8.1/local/lib/python2.7/site-packages/sage/modules/fg_pid/fgp_module.py\", line 357, in __init__\n    if not W.is_submodule(V):\n  File \"/ext/sage/sage-8.1/local/lib/python2.7/site-packages/sage/modules/free_module.py\", line 1103, in is_submodule\n    M = other.basis_matrix().solve_left(self.basis_matrix())\n  File \"sage/matrix/matrix2.pyx\", line 211, in sage.matrix.matrix2.Matrix.solve_left (build/cythonized/sage/matrix/matrix2.c:5903)\n    return self.transpose().solve_right(B.transpose(), check=check).transpose()\n  File \"sage/matrix/matrix2.pyx\", line 439, in sage.matrix.matrix2.Matrix.solve_right (build/cythonized/sage/matrix/matrix2.c:7948)\n    if self.rank() != self.nrows():\n  File \"sage/matrix/matrix_rational_dense.pyx\", line 2433, in sage.matrix.matrix_rational_dense.Matrix_rational_dense.rank (build/cythonized/sage/matrix/matrix_rational_dense.c:22725)\n    self.echelon_form(algorithm='flint')\n  File \"sage/matrix/matrix_rational_dense.pyx\", line 1665, in sage.matrix.matrix_rational_dense.Matrix_rational_dense.echelon_form (build/cythonized/sage/matrix/matrix_rational_dense.c:16493)\n    E = self.__copy__()\n  File \"sage/matrix/matrix_rational_dense.pyx\", line 598, in sage.matrix.matrix_rational_dense.Matrix_rational_dense.__copy__ (build/cythonized/sage/matrix/matrix_rational_dense.c:8194)\n    ans = Matrix_rational_dense.__new__(Matrix_rational_dense, self._parent, None, None, None)\n  File \"sage/matrix/matrix_rational_dense.pyx\", line 141, in sage.matrix.matrix_rational_dense.Matrix_rational_dense.__cinit__ (build/cythonized/sage/matrix/matrix_rational_dense.c:4064)\n    Matrix_dense.__init__(self, parent)\n  File \"sage/matrix/matrix0.pyx\", line 122, in sage.matrix.matrix0.Matrix.__init__ (build/cythonized/sage/matrix/matrix0.c:3943)\n    self._nrows = parent.nrows()\n  File \"/ext/sage/sage-8.1/local/lib/python2.7/site-packages/sage/matrix/matrix_space.py\", line 1613, in nrows\n    def nrows(self):\n  File \"src/cysignals/signals.pyx\", line 251, in cysignals.signals.python_check_interrupt\n  File \"src/cysignals/signals.pyx\", line 94, in cysignals.signals.sig_raise_exception\nKeyboardInterrupt\n"}︡{"done":true}
︠b280b75f-5af7-408b-8636-84d5854c65c4︠









